package grails.drools6

import org.kie.api.KieServices
import org.kie.api.builder.KieBuilder
import org.kie.api.builder.KieFileSystem
import org.kie.api.builder.KieModule
import org.kie.api.builder.KieRepository
import org.kie.api.io.Resource
import org.kie.api.io.ResourceType
import org.kie.api.runtime.KieContainer
import org.kie.api.runtime.KieSession
//import org.kie.internal.builder.KnowledgeBuilderConfiguration
//import org.kie.internal.builder.KnowledgeBuilderError
//import org.kie.internal.builder.KnowledgeBuilderErrors
//import org.kie.internal.builder.KnowledgeBuilderFactory
//import org.kie.internal.builder.conf.PropertySpecificOption
//import org.kie.internal.io.ResourceFactory


class DroolsService {

    private static String getRule1() {
        String s = "" +
                "package org.drools.example.api.kiefilesystem \n\n" +
                "import org.drools.example.api.kiefilesystem.Message \n\n" +
                "global java.io.PrintStream out \n\n" +
                "rule \"rule 1\" when \n" +
                "    m : Message( ) \n" +
                "then \n" +
                "    out.println( m.getName() + \": \" +  m.getText() ); \n" +
                "end \n" +
                "rule \"rule 2\" when \n" +
                "    Message( text == \"Hello, HAL. Do you read me, HAL?\" ) \n" +
                "then \n" +
                "    insert( new Message(\"HAL\", \"Dave. I read you.\" ) ); \n" +
                "end";

        return s;
    }

    private static String getRule() {
        return """
package grails.drools6;

global java.io.PrintStream out

rule "hello"
    then
        out.print("ok");
end
"""
    }

    def loadEngine() {
        KieServices ks = KieServices.Factory.get();
        KieRepository kr = ks.getRepository();
        KieFileSystem kfs = ks.newKieFileSystem();

//        String drl = new File("src/groovy/com/xtmotion/builder/xtrules.drl").getText()
//        kfs.write("src/main/resources/org/kie/example5/HAL5.drl", drl);

        KieBuilder kb = ks.newKieBuilder(kfs);

        kb.buildAll(); // kieModule is automatically deployed to KieRepository if successfully built.

        KieContainer kContainer = ks.newKieContainer(kr.getDefaultReleaseId());

        KieSession kSession = kContainer.newKieSession();
//        kSession.setGlobal("out", out);

//        kSession.insert(new Message("Dave", "Hello, HAL. Do you read me, HAL?"));
        kSession.fireAllRules();
    }
}
